Index: trunk/src/VBox/Main/src-client/GuestDirectoryImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestDirectoryImpl.cpp	(revision 91515)
+++ trunk/src/VBox/Main/src-client/GuestDirectoryImpl.cpp	(revision 91516)
@@ -417,5 +417,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Directory, rcGuest, mData.mOpenInfo.mPath.c_str());
                 hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Closing guest directory failed: %s"),
-                                       GuestBase::getErrorAsString(ge).c_str());
+                                  GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -460,5 +460,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_ToolLs, rcGuest, mData.mOpenInfo.mPath.c_str());
                 hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Reading guest directory failed: %s"),
-                                       GuestBase::getErrorAsString(ge).c_str());
+                                  GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
Index: trunk/src/VBox/Main/src-client/GuestFileImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestFileImpl.cpp	(revision 91515)
+++ trunk/src/VBox/Main/src-client/GuestFileImpl.cpp	(revision 91516)
@@ -1391,5 +1391,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_File, rcGuest, mData.mOpenInfo.mFilename.c_str());
             return setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Closing guest file failed: %s"),
-                                     GuestBase::getErrorAsString(ge).c_str());
+                                GuestBase::getErrorAsString(ge).c_str());
         }
         return setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Closing guest file \"%s\" failed with %Rrc\n"),
@@ -1434,5 +1434,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, mData.mOpenInfo.mFilename.c_str());
             hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file information failed: %s"),
-                                   GuestBase::getErrorAsString(ge).c_str());
+                              GuestBase::getErrorAsString(ge).c_str());
         }
         else
@@ -1467,5 +1467,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, mData.mOpenInfo.mFilename.c_str());
             hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file size failed: %s"),
-                                   GuestBase::getErrorAsString(ge).c_str());
+                              GuestBase::getErrorAsString(ge).c_str());
         }
         else
Index: trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 91515)
+++ trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 91516)
@@ -1788,5 +1788,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Process, rcGuest, mData.mProcess.mExecutable.c_str());
                 hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Reading %RU32 bytes from guest process handle %RU32 failed: %s"),
-                                       aToRead, aHandle, GuestBase::getErrorAsString(ge).c_str());
+                                  aToRead, aHandle, GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -1823,5 +1823,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Process, rcGuest, mData.mProcess.mExecutable.c_str());
                 hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Terminating guest process failed: %s"),
-                                       GuestBase::getErrorAsString(ge).c_str());
+                                  GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -1884,5 +1884,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Process, rcGuest, mData.mProcess.mExecutable.c_str());
                 hr = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Waiting for guest process (flags %#x) failed: %s"),
-                                       aWaitFor, GuestBase::getErrorAsString(ge).c_str());
+                                  aWaitFor, GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
Index: trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 91515)
+++ trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 91516)
@@ -3066,5 +3066,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_Session, rcGuest, mData.mSession.mName.c_str());
             return setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Closing guest session failed: %s"),
-                                     GuestBase::getErrorAsString(ge).c_str());
+                                GuestBase::getErrorAsString(ge).c_str());
         }
         return setError(VBOX_E_IPRT_ERROR, tr("Closing guest session \"%s\" failed with %Rrc"),
@@ -3171,8 +3171,7 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Process, rcGuest, (*itSource).c_str());
                 return setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying type for guest source failed: %s"),
-                                         GuestBase::getErrorAsString(ge).c_str());
+                                    GuestBase::getErrorAsString(ge).c_str());
             }
-            else
-                return setError(E_FAIL, tr("Querying type for guest source \"%s\" failed: %Rrc"), (*itSource).c_str(), vrc);
+            return setError(E_FAIL, tr("Querying type for guest source \"%s\" failed: %Rrc"), (*itSource).c_str(), vrc);
         }
 
@@ -3397,22 +3396,19 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_Directory, rcGuest, aPath.c_str());
             return setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Guest directory creation failed: %s"),
-                                     GuestBase::getErrorAsString(ge).c_str());
-        }
-        else
-        {
-            switch (vrc)
-            {
-                case VERR_INVALID_PARAMETER:
-                    hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: Invalid parameters given"));
-                    break;
-
-                case VERR_BROKEN_PIPE:
-                    hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: Unexpectedly aborted"));
-                    break;
-
-                default:
-                    hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: %Rrc"), vrc);
-                    break;
-            }
+                                GuestBase::getErrorAsString(ge).c_str());
+        }
+        switch (vrc)
+        {
+            case VERR_INVALID_PARAMETER:
+                hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: Invalid parameters given"));
+                break;
+
+            case VERR_BROKEN_PIPE:
+                hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: Unexpectedly aborted"));
+                break;
+
+            default:
+                hrc = setErrorBoth(VBOX_E_IPRT_ERROR, vrc, tr("Guest directory creation failed: %Rrc"), vrc);
+                break;
         }
     }
@@ -3447,5 +3443,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_ToolMkTemp, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Temporary guest directory creation failed: %s"),
-                                         GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -3492,5 +3488,5 @@
                         GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, aPath.c_str());
                         hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying directory existence failed: %s"),
-                                                 GuestBase::getErrorAsString(ge).c_str());
+                                           GuestBase::getErrorAsString(ge).c_str());
                         break;
                     }
@@ -3564,5 +3560,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Directory, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Opening guest directory failed: %s"),
-                                         GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -3605,5 +3601,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Directory, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Removing guest directory failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -3687,5 +3683,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Directory, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Recursively removing guest directory failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -3834,5 +3830,5 @@
                     GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, aPath.c_str());
                     hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file existence failed: %s"),
-                                            GuestBase::getErrorAsString(ge).c_str());
+                                       GuestBase::getErrorAsString(ge).c_str());
                     break;
                 }
@@ -3955,5 +3951,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_File, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Opening guest file failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -3988,5 +3984,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, aPath.c_str());
             hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file size failed: %s"),
-                                    GuestBase::getErrorAsString(ge).c_str());
+                               GuestBase::getErrorAsString(ge).c_str());
         }
         else
@@ -4033,5 +4029,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, aPath.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file existence information failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
             }
         }
@@ -4075,5 +4071,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_ToolStat, rcGuest, aPath.c_str());
             hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Querying guest file information failed: %s"),
-                                    GuestBase::getErrorAsString(ge).c_str());
+                               GuestBase::getErrorAsString(ge).c_str());
         }
         else
@@ -4103,5 +4099,5 @@
             GuestErrorInfo ge(GuestErrorInfo::Type_ToolRm, rcGuest, aPath.c_str());
             hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Removing guest file failed: %s"),
-                                    GuestBase::getErrorAsString(ge).c_str());
+                               GuestBase::getErrorAsString(ge).c_str());
         }
         else
@@ -4165,5 +4161,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Process, rcGuest, aSource.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Renaming guest path failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }
@@ -4402,5 +4398,5 @@
                 GuestErrorInfo ge(GuestErrorInfo::Type_Session, rcGuest, mData.mSession.mName.c_str());
                 hrc = setErrorBoth(VBOX_E_IPRT_ERROR, rcGuest, tr("Waiting for guest process failed: %s"),
-                                        GuestBase::getErrorAsString(ge).c_str());
+                                   GuestBase::getErrorAsString(ge).c_str());
                 break;
             }