Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 91521)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 91522)
@@ -229,5 +229,5 @@
 {
     /* Clear appliance: */
-    m_comAppliance = CAppliance();
+    m_comCloudAppliance = CAppliance();
     /* Clear form properties: */
     m_comVSDForm = CVirtualSystemDescriptionForm();
@@ -249,11 +249,11 @@
 
             /* Remember appliance: */
-            m_comAppliance = comAppliance;
+            m_comCloudAppliance = comAppliance;
 
             /* Read cloud instance info: */
-            CProgress comReadProgress = m_comAppliance.Read(QString("OCI://%1/%2").arg(profileName(), machineId()));
-            if (!m_comAppliance.isOk())
-            {
-                msgCenter().cannotImportAppliance(m_comAppliance);
+            CProgress comReadProgress = m_comCloudAppliance.Read(QString("OCI://%1/%2").arg(profileName(), machineId()));
+            if (!m_comCloudAppliance.isOk())
+            {
+                msgCenter().cannotImportAppliance(m_comCloudAppliance);
                 break;
             }
@@ -264,13 +264,13 @@
             if (!comReadProgress.isOk() || comReadProgress.GetResultCode() != 0)
             {
-                msgCenter().cannotImportAppliance(comReadProgress, m_comAppliance.GetPath());
+                msgCenter().cannotImportAppliance(comReadProgress, m_comCloudAppliance.GetPath());
                 break;
             }
 
             /* Acquire virtual system description: */
-            QVector<CVirtualSystemDescription> descriptions = m_comAppliance.GetVirtualSystemDescriptions();
-            if (!m_comAppliance.isOk())
-            {
-                msgCenter().cannotAcquireVirtualSystemDescription(m_comAppliance);
+            QVector<CVirtualSystemDescription> descriptions = m_comCloudAppliance.GetVirtualSystemDescriptions();
+            if (!m_comCloudAppliance.isOk())
+            {
+                msgCenter().cannotAcquireVirtualSystemDescription(m_comCloudAppliance);
                 break;
             }
@@ -352,5 +352,5 @@
 CAppliance UIWizardImportAppPage1::cloudAppliance() const
 {
-    return m_comAppliance;
+    return m_comCloudAppliance;
 }
 
@@ -677,5 +677,5 @@
         populateFormProperties();
         /* And make sure they are not null: */
-        return m_comAppliance.isNotNull() && m_comVSDForm.isNotNull();
+        return m_comCloudAppliance.isNotNull() && m_comVSDForm.isNotNull();
     }
     else
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 91521)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 91522)
@@ -116,6 +116,6 @@
     /** Holds the Cloud Client object reference. */
     CCloudClient                   m_comCloudClient;
-    /** Holds the Appliance object reference. */
-    CAppliance                     m_comAppliance;
+    /** Holds the Cloud Appliance object reference. */
+    CAppliance                     m_comCloudAppliance;
     /** Holds the Virtual System Description Form object reference. */
     CVirtualSystemDescriptionForm  m_comVSDForm;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 91521)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 91522)
@@ -328,5 +328,5 @@
                       && !m_comCloudClient.isNull()
                       && !machineId().isNull()
-                      && !m_comAppliance.isNull()
+                      && !m_comCloudAppliance.isNull()
                       && !m_comVSDForm.isNull());
     }