Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp	(revision 91553)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsNetwork.cpp	(revision 91554)
@@ -257,6 +257,6 @@
         /** Holds the attachment type label instance. */
         QLabel                    *m_pLabelAttachmentType;
-        /** Holds the adapter name label instance. */
-        QLabel                    *m_pLabelAdapterName;
+        /** Holds the network name label instance. */
+        QLabel                    *m_pLabelNetworkName;
         /** Holds the attachment type editor instance. */
         UINetworkAttachmentEditor *m_pEditorAttachmentType;
@@ -303,5 +303,5 @@
     , m_pWidgetAdvancedSettings(0)
     , m_pLabelAttachmentType(0)
-    , m_pLabelAdapterName(0)
+    , m_pLabelNetworkName(0)
     , m_pEditorAttachmentType(0)
     , m_pButtonAdvanced(0)
@@ -597,5 +597,5 @@
     m_pLabelAttachmentType->setEnabled(m_pParent->isMachineInValidMode());
     m_pEditorAttachmentType->setEnabled(m_pParent->isMachineInValidMode());
-    m_pLabelAdapterName->setEnabled(m_pParent->isMachineInValidMode() &&
+    m_pLabelNetworkName->setEnabled(m_pParent->isMachineInValidMode() &&
                                     attachmentType() != KNetworkAttachmentType_Null &&
                                     attachmentType() != KNetworkAttachmentType_NAT);
@@ -662,6 +662,6 @@
     m_pEditorAttachmentType->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Selects how this virtual adapter "
                                                                   "is attached to the real network of the Host OS."));
-    m_pLabelAdapterName->setText(QApplication::translate("UIMachineSettingsNetwork", "&Name:"));
-    iFirstColumnWidth = qMax(iFirstColumnWidth, m_pLabelAdapterName->minimumSizeHint().width());
+    m_pLabelNetworkName->setText(QApplication::translate("UIMachineSettingsNetwork", "&Name:"));
+    iFirstColumnWidth = qMax(iFirstColumnWidth, m_pLabelNetworkName->minimumSizeHint().width());
     m_pButtonAdvanced->setText(QApplication::translate("UIMachineSettingsNetwork", "A&dvanced"));
     m_pButtonAdvanced->setWhatsThis(QApplication::translate("UIMachineSettingsNetwork", "Shows additional network adapter options."));
@@ -720,5 +720,5 @@
 {
     /* Update alternative-name combo-box availability: */
-    m_pLabelAdapterName->setEnabled(attachmentType() != KNetworkAttachmentType_Null &&
+    m_pLabelNetworkName->setEnabled(attachmentType() != KNetworkAttachmentType_Null &&
                                     attachmentType() != KNetworkAttachmentType_NAT);
     /* Update promiscuous-mode combo-box availability: */
@@ -835,9 +835,9 @@
                 }
                 /* Prepare adapter name label: */
-                m_pLabelAdapterName = new QLabel(m_pWidgetAdapterSettings);
-                if (m_pLabelAdapterName)
+                m_pLabelNetworkName = new QLabel(m_pWidgetAdapterSettings);
+                if (m_pLabelNetworkName)
                 {
-                    m_pLabelAdapterName->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-                    m_pLayoutAdapterSettings->addWidget(m_pLabelAdapterName, 1, 0);
+                    m_pLabelNetworkName->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+                    m_pLayoutAdapterSettings->addWidget(m_pLabelNetworkName, 1, 0);
                 }
                 /* Prepare attachment type editor: */
@@ -847,6 +847,6 @@
                     if (m_pLabelAttachmentType)
                         m_pLabelAttachmentType->setBuddy(m_pEditorAttachmentType->focusProxy1());
-                    if (m_pLabelAdapterName)
-                        m_pLabelAdapterName->setBuddy(m_pEditorAttachmentType->focusProxy2());
+                    if (m_pLabelNetworkName)
+                        m_pLabelNetworkName->setBuddy(m_pEditorAttachmentType->focusProxy2());
 
                     m_pLayoutAdapterSettings->addWidget(m_pEditorAttachmentType, 0, 1, 2, 3);