Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 91579)
@@ -1765,5 +1765,4 @@
 UIApplianceEditorWidget::UIApplianceEditorWidget(QWidget *pParent /* = 0 */)
     : QIWithRetranslateUI<QWidget>(pParent)
-    , m_pAppliance(0)
     , m_pModel(0)
 {
@@ -1848,4 +1847,9 @@
     /* Translate finally: */
     retranslateUi();
+}
+
+void UIApplianceEditorWidget::setAppliance(const CAppliance &comAppliance)
+{
+    m_comAppliance = comAppliance;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.h	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.h	(revision 91579)
@@ -34,4 +34,5 @@
 /* COM includes: */
 #include "COMEnums.h"
+#include "CAppliance.h"
 #include "CVirtualSystemDescription.h"
 
@@ -294,11 +295,9 @@
     UIApplianceEditorWidget(QWidget *pParent = 0);
 
+    /** Defines @a comAppliance wrapper instance. */
+    virtual void setAppliance(const CAppliance &comAppliance);
+
     /** Defines the list of VSD @a hints. */
     void setVsdHints(const AbstractVSDParameterList &hints);
-
-    /** Returns whether the Appliance Editor has valid state. */
-    bool isValid() const { return m_pAppliance != 0; }
-    /** Returns the currently set appliance reference. */
-    CAppliance *appliance() const { return m_pAppliance; }
 
     /** Defines virtual system base folder @a strPath. */
@@ -324,9 +323,10 @@
     virtual void retranslateUi() /* override */;
 
+    /** Holds the currently set appliance reference. */
+    CAppliance  m_comAppliance;
+
     /** Holds the list of VSD hints. */
     AbstractVSDParameterList  m_listVsdHints;
 
-    /** Holds the currently set appliance reference. */
-    CAppliance         *m_pAppliance;
     /** Holds the Appliance model reference. */
     UIApplianceModel *m_pModel;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.cpp	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.cpp	(revision 91579)
@@ -63,6 +63,6 @@
 void UIApplianceExportEditorWidget::setAppliance(const CAppliance &comAppliance)
 {
-    /* Cache newly passed appliance: */
-    m_comAppliance = comAppliance;
+    /* Call to base-class: */
+    UIApplianceEditorWidget::setAppliance(comAppliance);
 
     /* Cleanup previous stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.h	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceExportEditorWidget.h	(revision 91579)
@@ -39,13 +39,8 @@
 
     /** Assigns @a comAppliance and populates widget contents. */
-    void setAppliance(const CAppliance &comAppliance);
+    virtual void setAppliance(const CAppliance &comAppliance) /* override final */;
 
     /** Prepares export by pushing edited data back to appliance. */
     void prepareExport();
-
-private:
-
-    /** Holds the appliance wrapper instance. */
-    CAppliance  m_comAppliance;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.cpp	(revision 91579)
@@ -50,6 +50,6 @@
 void UIApplianceImportEditorWidget::setAppliance(const CAppliance &comAppliance)
 {
-    /* Cache newly passed appliance: */
-    m_comAppliance = comAppliance;
+    /* Call to base-class: */
+    UIApplianceEditorWidget::setAppliance(comAppliance);
 
     /* Cleanup previous stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.h	(revision 91578)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceImportEditorWidget.h	(revision 91579)
@@ -39,13 +39,8 @@
 
     /** Assigns @a comAppliance and populates widget contents. */
-    void setAppliance(const CAppliance &comAppliance);
+    virtual void setAppliance(const CAppliance &comAppliance) /* override final */;
 
     /** Prepares import by pushing edited data back to appliance. */
     void prepareImport();
-
-private:
-
-    /** Holds the appliance wrapper instance. */
-    CAppliance  m_comAppliance;
 };
 