Index: /trunk/debian/rules
===================================================================
--- /trunk/debian/rules	(revision 91846)
+++ /trunk/debian/rules	(revision 91847)
@@ -157,16 +157,16 @@
 	for d in $(wildcard /lib/modules/*); do \
 	    if [ -L $$d/build ]; then \
-		make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
-		make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
-		make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetflt || true) && \
-		make -C $(builddir)/bin/src/vboxnetflt KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetflt/Module.symvers all; \
-		make -C $(builddir)/bin/src/vboxnetadp KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetadp || true) && \
-		make -C $(builddir)/bin/src/vboxnetadp KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetadp/Module.symvers all; \
-		[ -d $(builddir)/bin/src/vboxpci ] && make -C $(builddir)/bin/src/vboxpci KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxpci || true) && \
-		make -C $(builddir)/bin/src/vboxpci KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxpci/Module.symvers all; \
-		true; \
+	        make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
+	        make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
+	        make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetflt || true) && \
+	        make -C $(builddir)/bin/src/vboxnetflt KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetflt/Module.symvers all; \
+	        make -C $(builddir)/bin/src/vboxnetadp KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetadp || true) && \
+	        make -C $(builddir)/bin/src/vboxnetadp KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetadp/Module.symvers all; \
+	        [ -d $(builddir)/bin/src/vboxpci ] && make -C $(builddir)/bin/src/vboxpci KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxpci || true) && \
+	        make -C $(builddir)/bin/src/vboxpci KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxpci/Module.symvers all; \
+	        true; \
 	    fi; \
 	done
@@ -209,6 +209,4 @@
 	$(if $(NOQT),,mv $(archdir)/virtualbox.desktop \
 	   $(prefix)/usr/share/applications/virtualbox.desktop)
-	$(if $(NOQT),,mv $(archdir)/virtualboxvm.desktop \
-	   $(prefix)/usr/share/applications/virtualboxvm.desktop)
 	install -d -g 0 -o 0 $(prefix)/usr/share/pixmaps
 	$(if $(NOQT),,install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor)
@@ -218,10 +216,10 @@
 	$(if $(NOQT),,cd $(archdir)/icons; for i in *; do \
 	    for j in $$i/virtualbox.*; do \
-		if [ -f $$j ]; then \
-		    if [ ! -d $(prefix)/usr/share/icons/hicolor/$$i/apps ]; then \
-			install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/apps; \
-		    fi; \
-		    mv $$j $(prefix)/usr/share/icons/hicolor/$$i/apps; \
-		fi; \
+	        if [ -f $$j ]; then \
+	            if [ ! -d $(prefix)/usr/share/icons/hicolor/$$i/apps ]; then \
+	                install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/apps; \
+	            fi; \
+	            mv $$j $(prefix)/usr/share/icons/hicolor/$$i/apps; \
+	        fi; \
 	    done; \
 	    install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/mimetypes; \
@@ -248,14 +246,14 @@
 	$(if $(NOMODS),,for d in $(moddir)/*; do \
 	    if [ -f $$d/vboxdrv.ko -a -f $$d/vboxnetflt.ko -a -f $$d/vboxnetadp.ko ]; then \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxdrv.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxdrv.ko; \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxnetflt.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxnetflt.ko; \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxnetadp.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxnetadp.ko; \
-		if [ -f $$d/vboxpci.ko ]; then \
-		    install -D -g 0 -o 0 -m 0644 \
-			$$d/vboxpci.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxpci.ko; \
-		fi \
+	        if [ -f $$d/vboxpci.ko ]; then \
+	            install -D -g 0 -o 0 -m 0644 \
+		        $$d/vboxpci.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxpci.ko; \
+	        fi \
 	    fi \
 	    done)
@@ -267,11 +265,11 @@
 	if [ -f $(prefix)/usr/lib/$(package)/libQt5CoreVBox.so.5 ]; then \
 	    $(vboxroot)/tools/linux.$(chrarch)/bin/chrpath \
-		--keepgoing --replace /usr/lib/$(package) \
-		$(prefix)/usr/lib/$(package)/*.so.5 \
-		$(prefix)/usr/lib/$(package)/plugins/platforms/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/platformthemes/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/sqldrivers/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/styles/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/xcbglintegrations/*.so; \
+	        --keepgoing --replace /usr/lib/$(package) \
+	        $(prefix)/usr/lib/$(package)/*.so.5 \
+	        $(prefix)/usr/lib/$(package)/plugins/platforms/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/platformthemes/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/sqldrivers/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/styles/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/xcbglintegrations/*.so; \
 	    echo "[Paths]" > $(prefix)/usr/lib/$(package)/qt.conf; \
 	    echo "Plugins = /usr/lib/$(package)/plugins" >> $(prefix)/usr/lib/$(package)/qt.conf; \
Index: /trunk/src/VBox/Installer/common/virtualbox.desktop.in
===================================================================
--- /trunk/src/VBox/Installer/common/virtualbox.desktop.in	(revision 91846)
+++ /trunk/src/VBox/Installer/common/virtualbox.desktop.in	(revision 91847)
@@ -3,6 +3,6 @@
 Version=1.0
 Name=@VBOX_PRODUCT@
-GenericName=Virtualization Software
-GenericName[de]=Virtualisierung Software
+GenericName=Virtual Machine
+GenericName[de]=Virtuelle Maschine
 GenericName[ru]=Виртуальная машина
 Type=Application
Index: unk/src/VBox/Installer/common/virtualboxvm.desktop.in
===================================================================
--- /trunk/src/VBox/Installer/common/virtualboxvm.desktop.in	(revision 91846)
+++ 	(revision )
@@ -1,24 +1,0 @@
-[Desktop Entry]
-Encoding=UTF-8
-Version=1.0
-Name=@VBOX_PRODUCT@
-GenericName=Virtual Machine
-GenericName[de]=Virtuelle Maschine
-GenericName[ru]=Виртуальная машина
-Type=Application
-Exec=VirtualBoxVM %U
-TryExec=VirtualBoxVM
-Keywords=virtualization;
-Keywords[de]=Virtualisierung;
-Keywords[ru]=виртуализация;
-MimeType=application/x-virtualbox-vbox;application/x-virtualbox-vbox-extpack;application/x-virtualbox-ovf;application/x-virtualbox-ova;
-DocPath=file://@VBOX_DOC_PATH@/UserManual.pdf
-Icon=virtualbox
-Categories=Emulator;System;
-Actions=Manager;
-StartupWMClass=VirtualBox Machine
-Comment=Run the virtual machine
-
-[Desktop Action Manager]
-Exec=VirtualBox
-Name=Run Virtual Machine
Index: /trunk/src/VBox/Installer/freebsd/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 91846)
+++ /trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 91847)
@@ -60,12 +60,8 @@
 	$(PATH_ROOT)/src/VBox/Frontends/VirtualBox/images/$(if $(VBOX_OSE),OSE,NonOSE)/VirtualBox_32px.png=>VBox.png \
 	$(if $(VBOX_OSE),,$(VBOX_BRAND_LICENSE_TXT)=>LICENSE) \
-	$(if $(VBOX_WITH_QTGUI),$(freebsd-misc_0_OUTDIR)/virtualbox.desktop,) \
-	$(if $(VBOX_WITH_QTGUI),$(freebsd-misc_0_OUTDIR)/virtualboxvm.desktop,)
+	$(if $(VBOX_WITH_QTGUI),$(freebsd-misc_0_OUTDIR)/virtualbox.desktop,)
 freebsd-misc_CLEAN = $(freebsd-misc_0_OUTDIR)/virtualbox.desktop
-freebsd-misc_CLEAN = $(freebsd-misc_0_OUTDIR)/virtualboxvm.desktop
 
 $$(PATH_freebsd-misc)/virtualbox.desktop: $(PATH_SUB_CURRENT)/virtualbox.desktop $(VBOX_VERSION_STAMP) | $$(dir $$@)
-	$(call MSG_GENERATE,,$@,$<)
-$$(PATH_freebsd-misc)/virtualboxvm.desktop: $(PATH_SUB_CURRENT)/virtualboxvm.desktop $(VBOX_VERSION_STAMP) | $$(dir $$@)
 	$(call MSG_GENERATE,,$@,$<)
 ifdef VBOX_PATH_PACKAGE_DOCS
@@ -157,6 +153,5 @@
  	$(foreach f,$(VBOX_APPROVED_GUI_LANGUAGES),nls/VirtualBox_$(f).qm nls/qt_$(f).qm)
  VBOX_FBSD_DESKTOP_FILE = \
-	virtualbox.desktop \
-	virtualboxvm.desktop
+	virtualbox.desktop
  VBOX_FBSD_ICON_FILE = \
 	VBox.png
Index: /trunk/src/VBox/Installer/freebsd/pkg_plist
===================================================================
--- /trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 91846)
+++ /trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 91847)
@@ -89,4 +89,4 @@
 lib/virtualbox/nls/VirtualBox_cs.qm
 share/applications/virtualbox.desktop
-share/applications/virtualboxvm.desktop
 share/pixmaps/VBox.png
+
Index: /trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 91847)
@@ -105,6 +105,5 @@
 	$(if $(VBOX_OSE),,$(VBOX_BRAND_LICENSE_TXT)=>LICENSE) \
 	$(linux-misc_0_OUTDIR)/generated.sh=>scripts/generated.sh \
-	$(if $(VBOX_WITH_QTGUI),$(linux-misc_0_OUTDIR)/virtualbox.desktop,) \
-	$(if $(VBOX_WITH_QTGUI),$(linux-misc_0_OUTDIR)/virtualboxvm.desktop,)
+	$(if $(VBOX_WITH_QTGUI),$(linux-misc_0_OUTDIR)/virtualbox.desktop,)
 ifeq ($(KBUILD_TYPE),asan)
 linux-misc_SOURCES += $(foreach lib,$(VBOX_GCC_SANITIZER_SO_FILES) \
@@ -113,6 +112,5 @@
 linux-misc_CLEAN = \
 	$(linux-misc_0_OUTDIR)/generated.sh \
-	$(linux-misc_0_OUTDIR)/virtualbox.desktop \
-	$(linux-misc_0_OUTDIR)/virtualboxvm.desktop
+	$(linux-misc_0_OUTDIR)/virtualbox.desktop
 
 $$(linux-misc_0_OUTDIR)/generated.sh: $(VBOX_VERSION_STAMP) $(VBOX_LNX_INST_DEP_ON_MAKEFILE) | $$(dir $$@)
@@ -125,9 +123,4 @@
 
 $$(linux-misc_0_OUTDIR)/virtualbox.desktop: $(VBOX_PATH_INST_COMMON_SRC)/virtualbox.desktop.in $(VBOX_VERSION_STAMP) | $$(dir $$@)
-	$(call MSG_GENERATE,,$@,$<)
-	$(QUIET)$(SED) -e "s+@VBOX_DOC_PATH@+$(VBOX_LNX_APP_DOCS)+" \
-		-e "s+@VBOX_PRODUCT@+$(VBOX_PRODUCT)+" \
-		--output $@ $<
-$$(linux-misc_0_OUTDIR)/virtualboxvm.desktop: $(VBOX_PATH_INST_COMMON_SRC)/virtualboxvm.desktop.in $(VBOX_VERSION_STAMP) | $$(dir $$@)
 	$(call MSG_GENERATE,,$@,$<)
 	$(QUIET)$(SED) -e "s+@VBOX_DOC_PATH@+$(VBOX_LNX_APP_DOCS)+" \
@@ -261,5 +254,4 @@
  VBOX_LNX_NO_STRIP += \
  	virtualbox.desktop \
-	virtualboxvm.desktop \
  	virtualbox.xml \
  	$(VBOX_LICENSE_FILES) \
Index: /trunk/src/VBox/Installer/linux/debian/rules
===================================================================
--- /trunk/src/VBox/Installer/linux/debian/rules	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/debian/rules	(revision 91847)
@@ -181,16 +181,16 @@
 	for d in $(wildcard /lib/modules/*); do \
 	    if [ -L $$d/build ]; then \
-		make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
-		make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
-		make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetflt || true) && \
-		make -C $(builddir)/bin/src/vboxnetflt KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetflt/Module.symvers all; \
-		make -C $(builddir)/bin/src/vboxnetadp KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetadp || true) && \
-		make -C $(builddir)/bin/src/vboxnetadp KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetadp/Module.symvers all; \
-		[ -d $(builddir)/bin/src/vboxpci ] && make -C $(builddir)/bin/src/vboxpci KERN_VER=$$(basename $$d) clean && \
-		(cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxpci || true) && \
-		make -C $(builddir)/bin/src/vboxpci KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxpci/Module.symvers all; \
-		true; \
+	        make -C $(builddir)/bin/src/vboxdrv KERN_VER=$$(basename $$d) clean && \
+	        make -C $(builddir)/bin/src/vboxdrv KBUILD_VERBOSE= KERN_VER=$$(basename $$d) all; \
+	        make -C $(builddir)/bin/src/vboxnetflt KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetflt || true) && \
+	        make -C $(builddir)/bin/src/vboxnetflt KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetflt/Module.symvers all; \
+	        make -C $(builddir)/bin/src/vboxnetadp KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxnetadp || true) && \
+	        make -C $(builddir)/bin/src/vboxnetadp KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxnetadp/Module.symvers all; \
+	        [ -d $(builddir)/bin/src/vboxpci ] && make -C $(builddir)/bin/src/vboxpci KERN_VER=$$(basename $$d) clean && \
+	        (cp $(builddir)/bin/src/vboxdrv/Module.symvers $(builddir)/bin/src/vboxpci || true) && \
+	        make -C $(builddir)/bin/src/vboxpci KBUILD_VERBOSE= KERN_VER=$$(basename $$d) KBUILD_EXTRA_SYMBOLS=$(builddir)/bin/src/vboxpci/Module.symvers all; \
+	        true; \
 	    fi; \
 	done
@@ -233,6 +233,4 @@
 	$(if $(NOQT),,mv $(archdir)/virtualbox.desktop \
 	   $(prefix)/usr/share/applications/virtualbox.desktop)
-	$(if $(NOQT),,mv $(archdir)/virtualboxvm.desktop \
-	   $(prefix)/usr/share/applications/virtualboxvm.desktop)
 	install -d -g 0 -o 0 $(prefix)/usr/share/pixmaps
 	$(if $(NOQT),,install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor)
@@ -242,10 +240,10 @@
 	$(if $(NOQT),,cd $(archdir)/icons; for i in *; do \
 	    for j in $$i/virtualbox.*; do \
-		if [ -f $$j ]; then \
-		    if [ ! -d $(prefix)/usr/share/icons/hicolor/$$i/apps ]; then \
-			install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/apps; \
-		    fi; \
-		    mv $$j $(prefix)/usr/share/icons/hicolor/$$i/apps; \
-		fi; \
+	        if [ -f $$j ]; then \
+	            if [ ! -d $(prefix)/usr/share/icons/hicolor/$$i/apps ]; then \
+	                install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/apps; \
+	            fi; \
+	            mv $$j $(prefix)/usr/share/icons/hicolor/$$i/apps; \
+	        fi; \
 	    done; \
 	    install -d -g 0 -o 0 $(prefix)/usr/share/icons/hicolor/$$i/mimetypes; \
@@ -272,14 +270,14 @@
 	$(if $(NOMODS),,for d in $(moddir)/*; do \
 	    if [ -f $$d/vboxdrv.ko -a -f $$d/vboxnetflt.ko -a -f $$d/vboxnetadp.ko ]; then \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxdrv.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxdrv.ko; \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxnetflt.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxnetflt.ko; \
-		install -D -g 0 -o 0 -m 0644 \
+	        install -D -g 0 -o 0 -m 0644 \
 		    $$d/vboxnetadp.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxnetadp.ko; \
-		if [ -f $$d/vboxpci.ko ]; then \
-		    install -D -g 0 -o 0 -m 0644 \
-			$$d/vboxpci.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxpci.ko; \
-		fi \
+	        if [ -f $$d/vboxpci.ko ]; then \
+	            install -D -g 0 -o 0 -m 0644 \
+		        $$d/vboxpci.ko $(prefix)/lib/modules/$$(basename $$d)/misc/vboxpci.ko; \
+	        fi \
 	    fi \
 	    done)
@@ -291,11 +289,11 @@
 	if [ -f $(prefix)/usr/lib/$(package)/libQt5CoreVBox.so.5 ]; then \
 	    $(vboxroot)/tools/linux.$(chrarch)/bin/chrpath \
-		--keepgoing --replace /usr/lib/$(package) \
-		$(prefix)/usr/lib/$(package)/*.so.5 \
-		$(prefix)/usr/lib/$(package)/plugins/platforms/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/platformthemes/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/sqldrivers/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/styles/*.so; \
-		$(prefix)/usr/lib/$(package)/plugins/xcbglintegrations/*.so; \
+	        --keepgoing --replace /usr/lib/$(package) \
+	        $(prefix)/usr/lib/$(package)/*.so.5 \
+	        $(prefix)/usr/lib/$(package)/plugins/platforms/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/platformthemes/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/sqldrivers/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/styles/*.so; \
+	        $(prefix)/usr/lib/$(package)/plugins/xcbglintegrations/*.so; \
 	    echo "[Paths]" > $(prefix)/usr/lib/$(package)/qt.conf; \
 	    echo "Plugins = /usr/lib/$(package)/plugins" >> $(prefix)/usr/lib/$(package)/qt.conf; \
Index: /trunk/src/VBox/Installer/linux/deffiles
===================================================================
--- /trunk/src/VBox/Installer/linux/deffiles	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/deffiles	(revision 91847)
@@ -103,5 +103,4 @@
     VBox.png \
     virtualbox.desktop \
-    virtualboxvm.desktop \
     src/ \
     src/include/ \
Index: /trunk/src/VBox/Installer/linux/install.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/install.sh	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/install.sh	(revision 91847)
@@ -339,5 +339,4 @@
     ln -sf $INSTALLATION_DIR/icons/128x128/virtualbox.png /usr/share/pixmaps/virtualbox.png
     ln -sf $INSTALLATION_DIR/virtualbox.desktop /usr/share/applications/virtualbox.desktop
-    ln -sf $INSTALLATION_DIR/virtualboxvm.desktop /usr/share/applications/virtualboxvm.desktop
     ln -sf $INSTALLATION_DIR/virtualbox.xml /usr/share/mime/packages/virtualbox.xml
     ln -sf $INSTALLATION_DIR/rdesktop-vrdp /usr/bin/rdesktop-vrdp
Index: /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec
===================================================================
--- /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/rpm/VirtualBox.tmpl.spec	(revision 91847)
@@ -197,5 +197,4 @@
 ln -s /usr/share/virtualbox/src/vboxhost $RPM_BUILD_ROOT/usr/src/vboxhost-%VER%
 mv virtualbox.desktop $RPM_BUILD_ROOT/usr/share/applications/virtualbox.desktop
-mv virtualboxvm.desktop $RPM_BUILD_ROOT/usr/share/applications/virtualboxvm.desktop
 mv VBox.png $RPM_BUILD_ROOT/usr/share/pixmaps/VBox.png
 %{!?is_ose: mv LICENSE $RPM_BUILD_ROOT%{VBOXDOCDIR}}
Index: /trunk/src/VBox/Installer/linux/uninstall.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/uninstall.sh	(revision 91846)
+++ /trunk/src/VBox/Installer/linux/uninstall.sh	(revision 91847)
@@ -89,5 +89,4 @@
   /usr/share/pixmaps/virtualbox.png \
   /usr/share/applications/virtualbox.desktop \
-  /usr/share/applications/virtualboxvm.desktop \
   /usr/share/mime/packages/virtualbox.xml \
   /usr/bin/rdesktop-vrdp \
Index: /trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 91846)
+++ /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 91847)
@@ -545,5 +545,4 @@
 		\
 		$(VBOX_PATH_INST_COMMON_SRC)/virtualbox.desktop.in \
-	    $(VBOX_PATH_INST_COMMON_SRC)/virtualboxvm.desktop.in \
 		$(VBOX_PATH_INST_COMMON_SRC)/virtualbox.xml \
 		$(VBOX_PATH_SOL_INST_SRC)/virtualbox.applications.in \
@@ -646,10 +645,5 @@
 		--output $(VBOX_PATH_SI_SCRATCH_PKG)/usr/share/applications/virtualbox.desktop \
 		$(VBOX_PATH_INST_COMMON_SRC)/virtualbox.desktop.in
-	$(SED) -e "s+@VBOX_PRODUCT@+$(VBOX_PRODUCT)+" \
-		-e "s+@VBOX_DOC_PATH@+/opt/VirtualBox+" \
-		--output $(VBOX_PATH_SI_SCRATCH_PKG)/usr/share/applications/virtualboxvm.desktop \
-		$(VBOX_PATH_INST_COMMON_SRC)/virtualboxvm.desktop.in
 	$(CHMOD) 0644 $(VBOX_PATH_SI_SCRATCH_PKG)/usr/share/applications/virtualbox.desktop
-	$(CHMOD) 0644 $(VBOX_PATH_SI_SCRATCH_PKG)/usr/share/applications/virtualboxvm.desktop
 
 # Desktop stuff in /usr/share/mime/packages/ (S10 cannot deal with icon information in virtualbox.xml).